﻿Module Module1


    Function crc16(message As String) As Integer
        'declare variables
        Dim message_lenght As Integer
        Dim xor_loops As Byte
        Dim message_byte_snip As String
        Dim message_byte As UInt16
        Dim crc As UInt16 = &HFFFF
        Dim poly As UInt16 = &HA001
        Dim rotate_carry As Boolean
        Dim mbyte As Byte
        Dim upper_crc As UInt16
        Dim lower_crc As UInt16

        'find string lenght
        message_lenght = Len(message) / 2

        'loop through message
        For mbyte = 1 To message_lenght * 2 Step 2
            'get message byte and convert to decimal
            message_byte_snip = Mid(message, mbyte, 2)
            message_byte = Convert.ToInt32(message_byte_snip, 16)
            'xor crc with message byte
            crc = crc Xor message_byte
            'xor 8 times
            For xor_loops = 1 To 8
                'check for carry
                If crc And 1 Then rotate_carry = True Else rotate_carry = False
                If rotate_carry = True Then crc = crc - 1
                crc = crc / 2
                'xor with poly if carry
                If rotate_carry Then crc = crc Xor poly
            Next xor_loops
        Next mbyte

        'byte swap
        upper_crc = (crc And &HFF00) / 256
        lower_crc = crc And &HFF
        'return crc
        crc16 = lower_crc * 256 + upper_crc

    End Function
End Module
