﻿Public Class frm_crc16
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        'This program finds the crc16 value for a hex trsing
        'David K Smith 2020


    End Sub

    Private Sub btn_crc_Click(sender As Object, e As EventArgs) Handles btn_crc.Click
        Dim message_string As String
        Dim message_lenght As Integer
        Dim xor_loops As Byte
        Dim message_byte_snip As String
        Dim message_byte As UInt16
        Dim crc As UInt16 = &HFFFF
        Dim poly As UInt16 = &HA001
        Dim rotate_carry As Boolean
        Dim mbyte As Byte
        Dim upper_crc As UInt16
        Dim lower_crc As UInt16
        Dim message_crc As String

        'clr
        crc_process.Text = ""
        'find string lenght
        message_string = txt_message.Text
        message_lenght = Len(message_string) / 2
        lbl_msg_lenght.Text = message_lenght


        'loop through message
        For mbyte = 1 To message_lenght * 2 Step 2
            'get message byte and convert to decimal
            message_byte_snip = Mid(message_string, mbyte, 2)
            message_byte = Convert.ToInt32(message_byte_snip, 16)
            crc_process.Text = crc_process.Text & "msg byte  " & message_byte_snip & vbCrLf


            'xor crc with message byte
            crc = crc Xor message_byte
            crc_process.Text = crc_process.Text & "xor           " & Hex(crc) & vbCrLf
            'xor 8 times
            For xor_loops = 1 To 8
                'check for carry
                If crc And 1 Then rotate_carry = True Else rotate_carry = False
                If rotate_carry = True Then crc = crc - 1
                crc = crc / 2
                'xor with poly if carry
                If rotate_carry = True Then crc = crc Xor poly
                'show message
                crc_process.Text = crc_process.Text & "rotate " & xor_loops & "   " & Hex(crc) & "   Carry:" & rotate_carry & vbCrLf
            Next xor_loops
        Next mbyte

        'byte swap
        upper_crc = (crc And &HFF00) / 256
        lower_crc = crc And &HFF
        message_crc = Hex(lower_crc) & Hex(upper_crc)
        lbl_crc.Text = message_crc

        'use function
        lbl_func.Text = Hex(crc16(txt_message.Text))
    End Sub


End Class
